> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Retrieve Network Security Group

GET https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/network-security-group/{networkSecurityGroupId}

Get a Network Security Group by ID

Org must have a Tenant entity. Instance must belong to Tenant. User must have `FORGE_TENANT_ADMIN` authorization role.


Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/network-security-group/get-network-security-group

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/network-security-group/{networkSecurityGroupId}:
    get:
      operationId: get-network-security-group
      summary: Retrieve Network Security Group
      description: >
        Get a Network Security Group by ID


        Org must have a Tenant entity. Instance must belong to Tenant. User must
        have `FORGE_TENANT_ADMIN` authorization role.
      tags:
        - subpackage_networkSecurityGroup
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: networkSecurityGroupId
          in: path
          required: true
          schema:
            type: string
        - name: includeRelation
          in: query
          description: Related entity to expand
          required: false
          schema:
            $ref: >-
              #/components/schemas/V2OrgOrgCarbideNetworkSecurityGroupNetworkSecurityGroupIdGetParametersIncludeRelation
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NetworkSecurityGroup'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '404':
          description: Error response when requested object is not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '500':
          description: Response when the API handler encounters an unexpected error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '501':
          description: Response when the API handler encounters an unexpected error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    V2OrgOrgCarbideNetworkSecurityGroupNetworkSecurityGroupIdGetParametersIncludeRelation:
      type: string
      enum:
        - Tenant
        - Site
      title: >-
        V2OrgOrgCarbideNetworkSecurityGroupNetworkSecurityGroupIdGetParametersIncludeRelation
    NetworkSecurityGroupStatus:
      type: string
      enum:
        - Pending
        - Provisioning
        - Ready
        - Deleting
        - Error
      description: Status values for Network Security Group objects
      title: NetworkSecurityGroupStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    NetworkSecurityGroupRuleDirection:
      type: string
      enum:
        - INGRESS
        - EGRESS
      title: NetworkSecurityGroupRuleDirection
    NetworkSecurityGroupRuleProtocol:
      type: string
      enum:
        - TCP
        - UDP
        - ICMP
        - ANY
      title: NetworkSecurityGroupRuleProtocol
    NetworkSecurityGroupRuleAction:
      type: string
      enum:
        - PERMIT
        - DENY
      title: NetworkSecurityGroupRuleAction
    NetworkSecurityGroupRule:
      type: object
      properties:
        name:
          type:
            - string
            - 'null'
        direction:
          $ref: '#/components/schemas/NetworkSecurityGroupRuleDirection'
        sourcePortRange:
          type:
            - string
            - 'null'
        destinationPortRange:
          type:
            - string
            - 'null'
        protocol:
          $ref: '#/components/schemas/NetworkSecurityGroupRuleProtocol'
        action:
          $ref: '#/components/schemas/NetworkSecurityGroupRuleAction'
        priority:
          type: integer
        sourcePrefix:
          type: string
        destinationPrefix:
          type: string
      required:
        - direction
        - protocol
        - action
        - sourcePrefix
        - destinationPrefix
      description: Aggregation of Network Security Group rules
      title: NetworkSecurityGroupRule
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    NetworkSecurityGroup:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        tenantId:
          type: string
          format: uuid
        status:
          $ref: '#/components/schemas/NetworkSecurityGroupStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        statefulEgress:
          type: boolean
        rules:
          type: array
          items:
            $ref: '#/components/schemas/NetworkSecurityGroupRule'
        labels:
          $ref: '#/components/schemas/Labels'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Network Security Group is an aggregate of security policies
      title: NetworkSecurityGroup
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/network-security-group/networkSecurityGroupId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```